--
-- Rcsid[] = "$Id: reg_8bit.vhd,v 2.1 1993/10/06 01:04:36 alex Exp $";
--

-- This is a component used to define all the registers
-- and buffers in the 8085.
   
entity reg_8bit is
port(Q: out bit_vector(0 to 7);
	 D: in bit_vector(0 to 7);
     CK, WRENABLE, CLEAR, PRESET: in bit);
end;

architecture structure of reg_8bit is

component buf8
port(BUF_OUT: out bit_vector(7 downto 0);
	 BUF_IN:  in  bit_vector(7 downto 0));
end component;

signal L: bit_vector(0 to 7);
signal n8: bit;

begin
R0  : DFF1 port map(L(0), D(0),n8,PRESET,CLEAR);
R1  : DFF1 port map(L(1), D(1),n8,PRESET,CLEAR); 
R2  : DFF1 port map(L(2), D(2),n8,PRESET,CLEAR);
R3  : DFF1 port map(L(3), D(3),n8,PRESET,CLEAR);
R4  : DFF1 port map(L(4), D(4),n8,PRESET,CLEAR);
R5  : DFF1 port map(L(5), D(5),n8,PRESET,CLEAR);
R6  : DFF1 port map(L(6), D(6),n8,PRESET,CLEAR);
R7  : DFF1 port map(L(7), D(7),n8,PRESET,CLEAR);
U8  : and_gate generic map(1,1) port map(n8,CK,WRENABLE);
U9  : buf8 port map(Q(0 to 7), L(0 to 7));
end structure;
